using System.Collections.Generic;
using System.Linq;
using Magiq.Tests.Entities.TestModel;
using Magiq.Tests.Support;
using NUnit.Framework;

namespace Magiq.Tests.Entities
{
    [TestFixture]
    public class MagiqToEntitiesInsertsTest : BaseMagiqProviderInsertsTest<EntityFrameworkTestClass>
    {
        protected override IMagiqTestConfigurator GetConfigurator()
        {
            return MagiqToEntitiesTestConfigurator.Current;
        }

        private static IQueryable<EntityFrameworkTestClass> GetList()
        {
            return new List<EntityFrameworkTestClass>
                       {
                           new EntityFrameworkTestClass
                               {
                                   StringProperty = "bla",
                                   IntProperty = 4
                               },
                           new EntityFrameworkTestClass
                               {
                                   StringProperty = "ble",
                                   IntProperty = 4
                               }
                       }.AsQueryable();
        }

        [Test]
        public virtual void ShouldNotTryToInsertIntoAList()
        {
            GetList().Insert(TestClassInstances
                     .Select(x => new EntityFrameworkTestClass
                                     {
                                         AnotherStringProperty = x.StringProperty,
                                         IntProperty = x.AnotherIntProperty,
                                         AnotherIntProperty = 4,
                                         StringProperty = "lala"
                                     }));

            MagiqMock.AssertWasUsed();
        }

        [Test]
        public void ShouldInsertRegularListIntoEntityFramework()
        {
            Destination.Insert(GetList().Select(x => new EntityFrameworkTestClass
                                 {
                                     AnotherStringProperty = x.StringProperty,
                                     IntProperty = x.AnotherIntProperty,
                                     AnotherIntProperty = 4,
                                     StringProperty = "lala"
                                 }));
        }
    }
}