using System.Collections.Generic;

namespace Magiq.Tests.TestModel
{
    public class CollectionTestDomain<TParent,TChildItem> where TParent : IParent<TChildItem>, new() where TChildItem : class, IChildItem, new()
    {
        public CollectionTestDomain()
        {
            ChildItems = new List<TChildItem>();
            Parents = new List<TParent>();
            for (var i = 0; i < 30; i++)
            {
                ChildItems.Add(new TChildItem
                                   {
                                       Name = i%3 == 0 ? "lala" : "lala" + i
                                   });
            }
            for (var i = 0; i < 10; i++)
            {
                Parents.Add(new TParent
                                {
                                    Name = "test" + i
                                });
            }
        }

        public List<TChildItem> ChildItems { get; private set; }
        public List<TParent> Parents { get; private set; }

        public void AddRelations()
        {
            for (var i = 0; i < 10; i++)
            {
                Parents[0].AddItem(ChildItems[i]);
                Parents[1].AddItem(ChildItems[i + 10]);
                Parents[2].AddItem(ChildItems[i + 20]);
            }
        }
    }
}